### INSTALLATION INSTRUCTIONS FOR ROCKY LINUX 8

# INSTALL DEPENDENCIES
```
   $ dnf -y install epel-release
   $ dnf -y install gcc cfitsio-devel cmake git json-devel
```

# CLONE AND UPDATE SUBMODULES
```
   $ git clone https://www.ict.inaf.it/gitlab/bias/fits-preprocessor.git
   $ git submodule update --recursive --init
```

# PREPARE THE ENVIRONMENT
```
   $ gcc --version
   if your gcc version >= 11 skip to the next section, otherwise run:
      $ dnf install gcc-toolset-12
      $ scl enable gcc-toolset-12 bash  
         # the previous command is mandatory before the install step
```
# BUILD SOFA LIBRARY
```
   $ cd ./deps/sofa/20231011/c/src/
   $ make
   $ cd ../../../../../
```

# INSTALL
```
   $ mkdir build
   $ cd build
   $ cmake -DCMAKE_INSTALL_PREFIX="YOUR_INSTALLATION_DIR" ..
   $ make all
   $ make install
```
# RUN
```
   $ cd "YOUR_INSTALLATION_DIR"/bin
   $ ./FitsPreprocessor.lnx <source_path> <destination_path>
        # "<source_path>" is the path containing the .raw files you want to process, or the .raw file itself
        # "<destination_path>" is the path where fits files will be written
```
