#pragma once

#include <cfitsio/fitsio.h>

#include <File_Receiver.h>
#include <Astri_MA_Generic.h>
#include <Packet_Structure_Json.h>

using namespace inaf::oasbo;

class AstriFitsProcessor {

protected:
	Receivers::FileReceiver *receiver;
	Packets::AstriMaGeneric *packet;
	std::string file_to_process;
	std::string destinationPath;

	Packets::PacketStructureJson *structureGen;
	Packets::PacketStructureJson *structureS22;
	Packets::PacketStructureJson *structureC11;
	Packets::PacketStructureJson *structureC14;
	Packets::PacketStructureJson *structureHK;
	Packets::PacketStructureJson *structureVHG;
	Packets::PacketStructureJson *structureVLG;

	std::string computeFitsFileName(std::string type_subtype);
	bool isFileNameConform();
	void printLog(std::ostream &os, std::string message);


public:
	AstriFitsProcessor(std::string file_to_process);

	void setFileToProcess(std::string file_to_process);
	std::string getFileToProcess();
	int startProcessing();
	int setDestinationPath(std::string destPath);
	std::string getDestinationPath();

};


